<?php
/*
Plugin Name: Gravity Meta
Plugin URI: http://www.barbadospropertylist.com
Description: A simple plugin to add query string params Gravity Form dynamic fields. Latest WP version and PHP 5.3.0 required.
Version: 1.0
Author: barbadospropertylist
Author URI: http://www.barbadospropertylist.com
License: GPLv2
*/
?>
<?php
//
// Codes for grabbing query string params, parseing them into name value pairs and storing them in a session array called gmeta_query_array
//
if ( !is_admin() ) {
	// Start sesssion
	// Store params in session array
	session_start();
	if ( isset( $_SERVER['QUERY_STRING'] ) && !empty($_SERVER['QUERY_STRING']) ) {
		$gmeta_query_string = $_SERVER['QUERY_STRING'];
		parse_str( $gmeta_query_string, $gmeta_query_array );
		foreach ( $gmeta_query_array as $key => $value ) {
			$_SESSION[ 'gmeta_query_array' ][$key] = $value;
		}
		if ( isset( $_COOKIE['gmeta_cookie'] ) ) {
			$gmeta_cookie = unserialize( urldecode( $_COOKIE['gmeta_cookie'] ) );
			$gmeta_merge_array = array_merge( $gmeta_query_array, $gmeta_cookie );
			setcookie( 'gmeta_cookie', urlencode( serialize( $gmeta_merge_array ) ), time()+60*60*24*30, '/' );
		} else {
			setcookie( 'gmeta_cookie', urlencode( serialize( $gmeta_query_array ) ), time()+60*60*24*30, '/' );
		}
	}
	// Print array and values in a comment in footer of page
	add_action( 'wp_footer', 'gmeta_query_echo', 100 );
	function gmeta_query_echo() {
		echo '<!-- Gravity Meta Session ';
		print_r ( $_SESSION[ 'gmeta_query_array' ] );
		echo '-->';
		echo '<!-- Gravity Meta Cookie ';
		print_r ( unserialize( urldecode( $_COOKIE['gmeta_cookie'] ) ) );
		echo '-->';
		echo '<!-- Gravity Meta All Cookies ';
		print_r ( $_COOKIE );
		echo '-->';
	}
	// Codes for populating dynamic fields with associated session array values if there is a match
	if ( isset( $_COOKIE['gmeta_cookie'] ) ) {
		$gmeta_cookie = unserialize( urldecode( $_COOKIE['gmeta_cookie'] ) );
		foreach ( $gmeta_cookie as $key => $value ) {
			add_filter( "gform_field_value_$key", function() use ( $value ) { return $value; } );
		}
		foreach ( $_SESSION[ 'gmeta_query_array' ] as $key => $value ) {
			add_filter( "gform_field_value_$key", function() use ( $value ) { return $value; } );
		}
	}
}
?>
<?php
/*  Copyright 2012  Barbados Property List (email : wordpress@barbadospropertylist.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
?>